#include <genSrc/TestFB.h>

#include <stdio.h>

/**Use static allocated data */
TestFB_s testFB_s = {0}; 


float exampleInputs[10][2] =
{ { 1.0f,   1.0f } 
, { 0.9f,   1.0f }
, { 0.8f,   1.0f }
, { 0.707f, 1.0f }
, { 0.707f, 0.9f }
, { 0.707f, 0.8f }
, { 0.707f, 0.707f }
, { 0.6f,   0.707f }
, { 0.5f,   0.707f }
, { 0.1f,   0.707f }
};


int32 exmplInp_c3[10][3] =
{ { 1, 2, 3}
, { 1, 2, 3}
, { 1, 2, 3}
, { 1, 2, 3}
, { 1, 2, 3}
, { 1, 2, 3}
, { 1, 2, 3}
, { 1, 2, 3}
, { 1, 2, 3}
, { 1, 2, 3}
};

int main() {

  TestFB_s* testFB = &testFB_s;   // use a stack local reference, better for debug.
  //xxx ctor_TestFB(testFB);
  //
  int ctInitAbort = 10;
  bool bInitOk;
  do {     //============================ initialization loop
    bInitOk = true;                    // expect all is initilized
//    if(!init_TestFB(testFB)) {
//      bInitOk = false;                 // if one module fails, repeat
//    }                                  // (we have here only ones)
  } while(!bInitOk && --ctInitAbort >0);
  //
  if(!bInitOk) {
    printf("System cannot run, internal error, intialization fails\n");
    return 10;
  } else {  //=========================== Heureka, run mode reached
    int ix;
    int ixMax = ARRAYLEN_emC(exampleInputs);
    for(ix = 0; ix < ixMax; ++ix) {         // usual a device runs cyclically, here only for each test data 
      //upd_TestFB(testFB);
      //
      float a = exampleInputs[ix][0];       // this is here test organization component test (very simple)
      float b = exampleInputs[ix][1];
      int32* c3 = &exmplInp_c3[ix][0];
      //calc_TestFB(testFB, c3, c3, a,b);     // THIS FUNCTIONALITY IS DESIGNED IN THE GRAPHIC
      //  
      float magn = 0;//myExample.fb1.magn;      // access internal value of core components for debug possible.
      //                                    // also access of known graphical module elements possible
      float y = 0; //myExample.dout.y;           // access the result on the output pin of the graphic module.
      printf("a=%2.3f b=%2.3f magn=%2.3f  y=%2.3f\n", a, b, magn, y);
    }
  } 
  printf("all is done, I can die\n");
  return 0;
}
