#ifndef HGUARD_Some_FBx_BasicTest
#define HGUARD_Some_FBx_BasicTest

#include <applstdef_emC.h>

typedef struct FBx_T {
  float y;
  float y2[2];
} FBx_s;


static inline void ctor_FBx(FBx_s* thiz){
};


static inline bool init_FBx(FBx_s* thiz){
  return true;
};



static inline void step_FBx(FBx_s* thiz, float a, float gain, float x) {
  thiz->y = gain * a + x;
}


/**Note: The upd is automatically created in BasicTest, this is not correct. 
 * TODO search why
 */
static inline void upd_FBx(FBx_s* thiz) {
  
}

//== CLASS_C FBy =============================================================================

typedef struct FBy_T {
  float y;
} FBy_s;


static inline void ctor_FBy(FBy_s* thiz){
};


static inline bool init_FBy(FBy_s* thiz){
  return true;
};



static inline void step_FBy(FBy_s* thiz, float a2[2]) {
  thiz->y = a2[1]+a2[0];
}


/**Note: The upd is automatically created in BasicTest, this is not correct. 
 * TODO search why
 */
static inline void upd_FBy(FBy_s* thiz) {
  
}


//== CLASS_C FBdt2F =============================================================================

typedef struct FBdt2F_T {
  float y;
} FBdt2F_s;


static inline void ctor_FBdt2F(FBdt2F_s* thiz){
};


static inline bool init_FBdt2F(FBdt2F_s* thiz){
  return true;
};



static inline void step_FBdt2F(FBdt2F_s* thiz, float x1) {
  thiz->y = x1;
}


/**Note: The upd is automatically created in BasicTest, this is not correct. 
 * TODO search why
 */
static inline void upd_FBdt2F(FBdt2F_s* thiz) {
  
}




//== CLASS_C Ts1FiltSimple =============================================================================

typedef struct Ts1FiltSimple_T {
  /**Factor for filtering. For longer Ts it is ~ Tstep/Ts, for example 0.01 filters 100 ms in 1 ms step.*/
  float f;
  /**The smoothed output*/
  float y, yz;
} Ts1FiltSimple_s;


static inline void ctor_Ts1FiltSimple(Ts1FiltSimple_s* thiz){
  thiz->y = 0;
};


static inline bool init_Ts1FiltSimple(Ts1FiltSimple_s* thiz, float fs){
  thiz->f = fs;
  return true;
};



static inline void step_Ts1FiltSimple(Ts1FiltSimple_s* thiz, float x) {
  thiz->y += thiz->f * (x - thiz->yz);  // the simple smooting function.
}


static inline void upd_Ts1FiltSimple(Ts1FiltSimple_s* thiz) {
  thiz->yz = thiz->y;       // updates the value for usage in next step time.
}



//== CLASS_C FBdtN =============================================================================

typedef struct FBdtN_T {
  float y;
} FBdtN_s;


static inline void ctor_FBdtN(FBdtN_s* thiz){
};


static inline bool init_FBdtN(FBdtN_s* thiz){
  return true;
};



static inline void step_FBdtN(FBdtN_s* thiz, float x1, float x2) {
  thiz->y = x1 + x2;
}


/**Note: The upd is automatically created in BasicTest, this is not correct. 
 * TODO search why
 */
static inline void upd_FBdtN(FBdtN_s* thiz) {
  
}



//== CLASS_C DStruct =============================================================================

typedef struct DStruct_T {
  float m, n, p, q;

} DStruct;






typedef struct FBvariant_dF_T {

  double_complex y1;

  float y2;

} FBvariant_dF_s;



static inline void ctor_FBvariant_dF(FBvariant_dF_s* thiz){
};


static inline bool init_FBvariant_dF(FBvariant_dF_s* thiz){
  return true;
};



static inline void step_FBvariant_dF(FBvariant_dF_s* thiz, double x1, double x2, float x3) {
  thiz->y1.re = x1;
}


/**Note: The upd is automatically created in BasicTest, this is not correct. 
 * TODO search why
 */
static inline void upd_FBvariant_dF(FBvariant_dF_s* thiz) {
  
}




#endif //HGUARD_Some_FBx_BasicTest