/**Generated by org.vishia.fbcl. made by Hartmut Schorrig, vishia.org script 2024-08-30 / 2024-08-30 */
#include "ExmplPositionCtrlPID_I.h"
#include <Adapt_PIDI.h>
#include <emC/Base/Math_emC.h>
#include <emC/Ctrl/PIDi_Ctrl_emC.h>
#include <emC\Ctrl\PIDf_Ctrl_emC.h>

#include <string.h>             // necessary for basic operations in C, also memcpy

// Note: Selection of verbose code comments for code generation with option -verboseCode possible.






/**Initialization
 */
bool init_ExmplPositionCtrlPID_I ( ExmplPositionCtrlPID_I_s* thiz
  , float kP
  , float Tn
  , float Td
  , float Tsd
  , int32 ymax
  , int16 fw
) {
  bool bInitOk = true;            // return value for this init_operation
  bool bInitOk1;                  // variable for the init_...() results
  
  thiz->mEvout_init = 0;  // set evout bits to 0, will be set maybe conditional otx: GenCode_cObj#mEvoutInit//
  // following statements from exec: prcEvchainOperation(...) 
  
  bInitOk1 = init_PIDI_Ctrl_emC(&thiz->ctrl, &thiz->ctrlp);        //$module_ExmplPositionCtrlPID.init --> ctrl.init  otx: initFB_evin
  bInitOk &= bInitOk1;   //note: do not combine &= init_...(...) it prevents execution if bInitOk = false 
  bInitOk1 = init_Par_PIDI_Ctrl_emC(&thiz->ctrlp, 0.00005, ymax, kP, Tn, Td, Tsd, 0, 0);        //$module_ExmplPositionCtrlPID.init --> ctrlp.init  otx: initFB_evin
  bInitOk &= bInitOk1;   //note: do not combine &= init_...(...) it prevents execution if bInitOk = false  
  
  thiz->fw = (fw);  //init --> fw_X.prep  genExprOut(...) in otx: setVar_FBexpr
  
  return bInitOk;
} // init_ExmplPositionCtrlPID_I





/**Operation stepslow(...)
 */
void stepslow_ExmplPositionCtrlPID_I ( ExmplPositionCtrlPID_I_s* thiz
  , int32 w
) {
  
  thiz->mEvout_stepslow = 0;  // set evout bits to 0, will be set maybe conditional otx: GenCode_cObj#mEvout//
  // following statements from exec: prcEvchainOperation(...) 
   
  
  thiz->w1 = (w);  //stepslow --> w1_X.prep  genExprOut(...) in otx: setVar_FBexpr
  
} // stepslow_ExmplPositionCtrlPID_I





/**Operation updslow(...)
 */
void updslow_ExmplPositionCtrlPID_I ( ExmplPositionCtrlPID_I_s* thiz
) {
  
  thiz->mEvout_updslow = 0;  // set evout bits to 0, will be set maybe conditional otx: GenCode_cObj#mEvout//
  // following statements from exec: prcEvchainOperation(...) 
  
  thiz->w1_z = thiz->w1;    // otx: VarZ_OFB_upd
  
} // updslow_ExmplPositionCtrlPID_I





/**Operation param(...)
 */
void param_ExmplPositionCtrlPID_I ( ExmplPositionCtrlPID_I_s* thiz
  , float kP
  , float Tn
  , float Td
  , float Tsd
  , bool reset
  , int16 fw
) {
  
  thiz->mEvout_param = 0;  // set evout bits to 0, will be set maybe conditional otx: GenCode_cObj#mEvout//
  // following statements from exec: prcEvchainOperation(...) 
  
  set_Par_PIDI_Ctrl_emC(&thiz->ctrlp, kP, Tn, Td, Tsd, reset);  //$module_ExmplPositionCtrlPID.param --> ctrlp.set  otx:callFB_evin 
  
  thiz->fw = (fw);  //param --> fw_X.prep  genExprOut(...) in otx: setVar_FBexpr
  
} // param_ExmplPositionCtrlPID_I





/**Operation step(...)
 */
void step_ExmplPositionCtrlPID_I ( ExmplPositionCtrlPID_I_s* thiz
  , int32 x
  , int32 x2
) {
  
  thiz->mEvout_step = 0;  // set evout bits to 0, will be set maybe conditional otx: GenCode_cObj#mEvout//
  // following statements from exec: prcEvchainOperation(...) 
  
  step_PIDI_Ctrl_emC(&thiz->ctrl, (-x + thiz->w1_z), 0);  //$module_ExmplPositionCtrlPID.step --> ctrl.step  otx:callFB_evin
  //
  //Module outputs due to the event stepO:  otx: evMldOutStart
  thiz->mEvout_step |= MASK_step_stepO;  // set the output event bit otx: evMldOutStart
  thiz->yCtrl = (thiz->ctrl.y + mpyIS_emC(thiz->w1_z, thiz->fw_z, 20, 8) );    // otx: setMdlOutScalar
  //end Module outputs due to the event stepO:  otx: evMldOutEnd
  //
  
} // step_ExmplPositionCtrlPID_I





/**Operation upd(...)
 */
void upd_ExmplPositionCtrlPID_I ( ExmplPositionCtrlPID_I_s* thiz
) {
  
  thiz->mEvout_upd = 0;  // set evout bits to 0, will be set maybe conditional otx: GenCode_cObj#mEvout//
  // following statements from exec: prcEvchainOperation(...) 
  
  upd_PIDI_Ctrl_emC(&thiz->ctrl);  //$module_ExmplPositionCtrlPID.upd --> ctrl.upd  otx:callFB_evin
  
} // upd_ExmplPositionCtrlPID_I





/**Operation updparam(...)
 */
void updparam_ExmplPositionCtrlPID_I ( ExmplPositionCtrlPID_I_s* thiz
) {
  
  thiz->mEvout_updparam = 0;  // set evout bits to 0, will be set maybe conditional otx: GenCode_cObj#mEvout//
  // following statements from exec: prcEvchainOperation(...) 
  
  thiz->fw_z = thiz->fw;    // otx: VarZ_OFB_upd
  
} // updparam_ExmplPositionCtrlPID_I





/**Operation ctor(...)
 */
void ctor_ExmplPositionCtrlPID_I ( ExmplPositionCtrlPID_I_s* thiz
) {
  thiz->mEvout_ctor = 0;  // set evout bits to 0, will be set maybe conditional otx: GenCode_cObj#mEvoutCtor//
  // following statements from exec: prcEvchainOperation(...) 
  
  
  ctor_PIDI_Ctrl_emC((ObjectJc*)&thiz->ctrl, 0.00005);     //$module_ExmplPositionCtrlPID.ctor --> ctrl.ctorObj  otx:ctorObjFB_evin
  ctor_Par_PIDI_Ctrl_emC((ObjectJc*)&thiz->ctrlp, 0.001);     //$module_ExmplPositionCtrlPID.ctor --> ctrlp.ctorObj  otx:ctorObjFB_evin
  
} // ctor_ExmplPositionCtrlPID_I




