#ifndef HGUARD_TestPositionCtrlPID_scope
#define HGUARD_TestPositionCtrlPID_scope

/**Generated by org.vishia.fbcl. made by Hartmut Schorrig, script 2025-03-27*/
#include <applstdef_emC.h>
#include <emC/Base/Endianness_emC.h>
#include <emC/Ipc/SocketComm_Ipc_emC.h>      // socket OSAL in emC
#include <emC/Ipc/DatagramHead_Ipc_emC.h>




/**Structure for the scope via ethernet. 
 */
typedef struct Scope_scope1_TestPositionCtrlPID_T {

  /**The Ethernet communication driver for PC. It is an OSAL-using part,
   * means can run under Windows as also under Linux, only by using the proper implementation files. */
  SocketComm_Ipc_emC_s socket;

  int32 scopeOk;

  int32 dummy1;   // for possible necessary 8-byte-alignment

  /**This data are exchanged via ethernet, received from the CurveViewApp.
   * for a proper handshake of data exchange. */
  struct ScopeRxData_T {
    DatagramHead_Ipc_emC_s head;    // it should be start on a even address dividable by 4.
    DatagramItem_Ipc_emC_s item1;   // this contains sequence numbers for answer.
    int32BigEndian anyValue[3];     // not used but possible to use, part of payload in ethernet.
    int32BigEndian reserve[16];
  } rxData;

  
  /**This data are exchanged via ethernet, received from the CurveViewApp.
   * for a proper handshake of data exchange. */
  struct ScopeTxData_T {
    DatagramHead_Ipc_emC_s head;    // it should be start on a even address dividable by 4.
    DatagramItem_Ipc_emC_s item1;
    int32BigEndian timesh;          // organization of time axis
    floatBigEndian time_ms;
  
    
    floatBigEndian w1;      // rd,0.2,0,50
    floatBigEndian x1;      // dgn,0.2,0,50
    floatBigEndian yCtrl;      // bl,0.2,0,50
  } txData;

  


} Scope_scope1_TestPositionCtrlPID_s;

struct TestPositionCtrlPID_T;     // struct forward declaration necessary for gcc

extern_C bool init_scope1_TestPositionCtrlPID ( Scope_scope1_TestPositionCtrlPID_s* scope, struct TestPositionCtrlPID_T const* mdl);

extern_C void sendValues_scope1_TestPositionCtrlPID ( Scope_scope1_TestPositionCtrlPID_s* scope, int32 step, struct TestPositionCtrlPID_T const* mdl);

extern_C void close_scope1_TestPositionCtrlPID ( Scope_scope1_TestPositionCtrlPID_s* scope);


#endif //HGUARD_TestPositionCtrlPID_scope
