#include <stdio.h>
#include <applstdef_emC.h>

#include "genSrc/TestPositionCtrlPID.h"
#include "genSrc/TestPositionCtrlPIDint.h"
#include "genSrc/TestPositionCtrlPID_scope.h"
#include "TimeSignalGen.h"

typedef struct MainData_T {
  TestPositionCtrlPID_s test_F;
  TestPositionCtrlPIDint_s test_I;
  Scope_scope1_TestPositionCtrlPID_s scope_F;
} MainData_s;

MainData_s maindata = {0};


int main(int argc, char** argv) {
  printf("testPositionCtrlPID");
  MainData_s* thiz = &maindata;
  ctor_TestPositionCtrlPID(&maindata.test_F);
  ctor_TestPositionCtrlPIDint(&maindata.test_I);
  bool bInitOk;
  int ctAbortInit = 100;
  init_scope1_TestPositionCtrlPID(&thiz->scope_F, &thiz->test_F);
  do {
    bool bInitOkPart;
    bInitOk = true;;
    bInitOkPart = init_TestPositionCtrlPID(&maindata.test_F);      // calls generated code
    bInitOk &= bInitOkPart;
    bInitOkPart = init_TestPositionCtrlPIDint(&maindata.test_I, 0.1f);      // calls generated code
    bInitOk &= bInitOkPart;
  } while(!bInitOk && --ctAbortInit >=0);
  if(ctAbortInit <0) {
    printf("ERROR init not successfull, abort\n");
    return 255;
  }
  //
  int nstepEnd = 20000; //runs for 1 second simulation time.
  int step = 0;
  int ctSlow = 1;
  int stepSlowPeriod = 20;
  //
  // This is the while loop for the simulation steps.
  while(++step < nstepEnd){
    upd_TestPositionCtrlPID(&maindata.test_F);   // calls generated code, update comes first.
    step_TestPositionCtrlPID(&maindata.test_F);   // calls generated code, update comes first.
    upd_TestPositionCtrlPIDint(&maindata.test_I);   // calls generated code, update comes first.
    step_TestPositionCtrlPIDint(&maindata.test_I);   // calls generated code, update comes first.
    if(--ctSlow <=0) {
      ctSlow = stepSlowPeriod;
      updSlow_TestPositionCtrlPID(&maindata.test_F);
      stepSlow_TestPositionCtrlPID(&maindata.test_F, step);
      updSlow_TestPositionCtrlPIDint(&maindata.test_I);
      stepSlow_TestPositionCtrlPIDint(&maindata.test_I, step);
    }
    if(step == 100){
      step +=0;
    }
    sendValues_scope1_TestPositionCtrlPID(&thiz->scope_F, step, &thiz->test_F);
  } // while step
  close_scope1_TestPositionCtrlPID(&thiz->scope_F);
}


#ifndef DEF_NO_THCXT_STACKTRC_EXC_emC
//void uncatched_Exception_emC ( Exception_emC* ythis, ThreadContext_emC_s* _thCxt){
//  printf("ERROR");
//}
#endif

void errorSystem_emC_  (  int errorCode, const char* description, int value1, int value2, char const* file, int line){
  printf("testPositionCtrlPID");


}
