#include <applstdef_emC.h>

#define NO_PARSE_ZbnfCheader

#include <emC/Ctrl/SignalGen_Ctrl_emC.h>

#include <emC/Inspc/FB/DataStructBase_Inspc.h>
#include <emC/Base/DefPortTypes_emC.h>
#include <emC/Jc/FileIoJc.h>
#include <emC/Jc/StringJc.h>
#include <emC/base/Object_emC.h>
#include <emC/J1c/StringFunctionsJc.h>
#include <emC/J1c/StringFunctions_CJc.h>
#include <emC/OSAL/os_mem.h>

#include <stdlib.h>
#include <string.h>
#include <math.h>

//#include <emC/Base/Math_emC.h>
#include <math.h>
#include <string.h>
#include <stdlib.h>

#if 0
//new since 2017-07-29, reengineered 2018-09
void ctor_TimeSignals_Inspc(TimeSignals_Inspc* thiz, float Tstep, struct DefPortTypes_emC_t* fbInfo, char const filepath[500], StringJc reflName, int zTimeData
  , char const outputDefinition[500]
) {
  STACKTRC_ENTRY("ctor_TimeSignals_Inspc");
  //xx ctor_DataStructBase_Inspc(&thiz->base.super, fbInfo, fbInfo->ixOutputVarg, fbInfo->nrofOutputs, outputDefinition);
  //
  thiz->par.stepsDynew = 2048;     //Time-steps to re-adjust the dya. Proper to 2^11 * 2^11 accuracy of floating point:
  //The addition of ddya to dya is done 2018 times. It is a chain error of numeric: Any addition has an accuracy of about 2^-23.
  //2048 additions may cause an error of 2^-12. The value-ratio dya/ddya is in range till -2^11 ..0. 
  //It means after about 2048 adding steps the error of dya reaches the range of the value of ddya. 
  //Therefore the growth dya should be determine newly after this steps for a longer constant growth (ramp in output value).
  //  
  thiz->par.testAddStepSpline = 2; //Experience: With this adding time the correcture is more exact.
  //
  thiz->Tstep = Tstep;
  //xx copyToBuffer_StringJc(reflName, 0, -1, thiz->nameModule, sizeof(thiz->nameModule));
  //now constructs.  
  memset(thiz->nrElements, 1, sizeof(thiz->nrElements));
  thiz->bitsComplexY = 0;
  //xx init_immediate_ObjectArrayJc(&thiz->superThiz.head, 1, sizeof(thiz->superThiz.data[0])
  //xx       , &refl_ClassOffset_idxVtblJc, ID_refl_ClassOffset_idxVtblJc | mArrayId_ObjectJc);
  //xx ctor_ClassOffset_idxVtblJc(&thiz->superThiz.data[0], &refl_TimeSignals_Inspc, 0x22, 0);
  //xx ctor_Fields_super_ClassJc(&thiz->clazz, z_StringJc(thiz->nameModule), 0, &thiz->fields.head, &thiz->superThiz.head);
  //
  //int ixFields = 0;
  //xx int zFields = fbInfo->nrofOutputs -1;  //last Field for thiz 
  //TODO alloc fields

  //unnecessary: int32 nrofValuesInt32 = evalSizes_DataStructBase_Inspc(&thiz->base.super);
  
  //xx evalNamesCreateFields_DataStructBase_Inspc(&thiz->base.super, &thiz->fields, 0, _thCxt);
  //
  //fill the correct offset. The field should refer only a part of the current values, which are the output values on pins.
  for(int ix = 0; ix < thiz->base.super.zVariable; ++ix) {
    thiz->base.super.varParams[ix].ixInVal = ix;
    thiz->fields.data[ix].offsFieldInStruct = offset_MemAreaC(thiz, &thiz->curr[ix].ya);  
  }

  thiz->fields.head.length = thiz->base.super.zVariable; // +1;
  //
  //Set the created fields as reflection of thiz
  setReflection_ObjectJc(&thiz->base.object, &thiz->clazz, -1);
  //
  //{ //store file name as char const*
  //  int zFilepath = copyToBuffer_StringJc(filepath, 0, -1, thiz->filepath, sizeof(thiz->filepath)-1);
  //  thiz->filepath[zFilepath] = 0;
  //PRINTF2("TimeSignals - Filepath %s\n", thiz->filepath);
  readConfig_TimeSignals_Inspc(thiz, filepath);
  //}
  STACKTRC_RETURN;





}
#endif







void dtor_TimeSignals_Inspc(TimeSignals_Inspc* thiz) {
  for (int ixChn = 0; ixChn < 16; ++ixChn) {
    TimeData_TimeSignals_Inspc* data = &thiz->timeData[ixChn];
    if(data->entriesChn !=null) {
      for(int ixEntry = 0; ixEntry < data->zEntryChn; ++ixEntry){
        free(data->entriesChn->d[ixEntry]);
      }
      free(data->entriesChn);
    }
  }
}


static int createNewEntry(TimeSignals_Inspc* thiz, int ixChn, float time) {
  TimeData_TimeSignals_Inspc* dataChn = &thiz->timeData[ixChn];
  if (dataChn->entriesChn == null) {
    int allocBytes = 1000 * sizeof(Entry_TimeSignals_Inspc*);
    Array_Entry_TimeSignals_Inspc* arrayEntries = (Array_Entry_TimeSignals_Inspc*) malloc(allocBytes);
    memset(arrayEntries, 0, allocBytes);
    dataChn->entriesChn = arrayEntries; //casting admissible, same type of pointer.
    if(time >0.0f) {
      Entry_TimeSignals_Inspc* entry0 = (Entry_TimeSignals_Inspc*) malloc(sizeof(Entry_TimeSignals_Inspc));
      memset(entry0, 0, sizeof(*entry0));
      dataChn->entriesChn->d[0] = entry0;
      dataChn->zEntryChn = 1;
    } else {
      dataChn->zEntryChn = 0;
    }
  }
  int ixEntry = 0;
  while (ixEntry < dataChn->zEntryChn && dataChn->entriesChn->d[ixEntry]->timeStart <= time){
    ixEntry +=1;  //search in time.
  }
  if(ixEntry < dataChn->zEntryChn){
    //move entries later
    memmove(&dataChn->entriesChn->d[ixEntry + 1], &dataChn->entriesChn->d[ixEntry], sizeof(void*) * (dataChn->zEntryChn - ixEntry));  //memmove(dst, src, length) 
  }
  dataChn->zEntryChn +=1;
  Entry_TimeSignals_Inspc* entry = (Entry_TimeSignals_Inspc*)malloc(sizeof(Entry_TimeSignals_Inspc));
  memset(entry, 0, sizeof(Entry_TimeSignals_Inspc));
  dataChn->entriesChn->d[ixEntry] = entry;
  return ixEntry;
}



static void parseLine_TimeSignals_Inspc(TimeSignals_Inspc* thiz, StringJc line, int posStart, int ixStartEntries[16], ThCxt* _thCxt)
{ int zLine = length_StringJc(line);
  int pos = posStart;
  STACKTRC_TENTRY("parseLine_TimeSignals_Inspc");
  int parsedCharsTime = 0;
  float time = parseFloat_CsiiciY_StringFunctions_CJc(line, pos, zLine, '.', &parsedCharsTime, _thCxt);
  float timespline;
  pos = indexNoWhitespace_StringFunctionsJc(line, pos + parsedCharsTime, -1, _thCxt);
  if(charAt_StringJc(line, pos) == '-') {  //a timeCorr given. Start of spline or correction.
    pos = indexNoWhitespace_StringFunctionsJc(line, pos +1, -1, _thCxt);
    timespline = parseFloat_CsiiciY_StringFunctions_CJc(line, pos, zLine, '.', null, _thCxt);
  } else {
    timespline = 0;  //no spline
  }
  int posColon = indexOf_CI_StringJc(line, ':', pos);
  if(posColon > 0 && parsedCharsTime >0) { //time found.
    pos = posColon +1;
    int maxWhileNext = 100;
    while(maxWhileNext >=0 && pos >0) { //search value asignments, pos is position after separator for values.
      int posName = indexNoWhitespace_StringFunctionsJc(line, pos, -1, _thCxt );
      pos = indexAfterIdentifier_StringFunctionsJc(line, posName, -1, null_StringJc, _thCxt );
      if(pos > posName && pos < zLine && charAt_StringJc(line, pos) == '.') {
        StringJc nameModule = substring_StringJc(line, posName, pos, _thCxt);
        if(equals_z_StringJc(nameModule, thiz->nameModule)) {
          posName = pos +1; //name inside moduel.
          pos = indexAfterIdentifier_StringFunctionsJc(line, posName, -1, null_StringJc, _thCxt );
          StringJc name = substring_StringJc(line, posName, pos, _thCxt);
          int ixName = -1;
          int zNames = thiz->base.super.zVariable;
          while(++ixName < zNames && !equals_z_StringJc(name, thiz->base.super.varParams[ixName].name));  //search name
          if(ixName < zNames) {
            //name in line found in this stimuli block:
            int posValue = indexOf_CI_StringJc(line, '=', pos) +1;
            if(posValue >0 ) { //if = not found, it is 0 because +1
              //an entry necessary: Search position:
              int ixEntry = createNewEntry(thiz, ixName, time);
              Entry_TimeSignals_Inspc* entry = thiz->timeData[ixName].entriesChn->d[ixEntry];
              entry->timeStart = time;
              int ixStartEntry = -1;  //no ramp
              if (charAt_StringJc(line, posValue) == '>') {  //ramp to target
                if (time > 0) {
                  entry->ramp = 1; //this entry should be reached with a ramp, not with jump
                  entry->timespline = timespline; //may be 0
                }
                posValue +=1;
              }
              
              int zValues = ARRAYLEN_emC(((Entry_TimeSignals_Inspc*)0)->ya);
              int ixValue = 0;
              int32 nrofCharsParsed;
              do {
                posValue = indexNoWhitespace_StringFunctionsJc(line, posValue, -1, _thCxt );
                float value = parseFloat_CsiiciY_StringFunctions_CJc(line, posValue, 99999, '.', &nrofCharsParsed, _thCxt);
                if(nrofCharsParsed > 0  //a value scanned?
                  && entry !=null       //an entry found? on not found entry parse the values but don't store.
                  ) {
                  entry->ya[ixValue++] = value;
                }
                //pos after value and spaces.
                //don't check ',' it is the separator between names.
                pos = indexNoWhitespace_StringFunctionsJc(line, posValue + nrofCharsParsed, -1, _thCxt );
                posValue = pos;
              } while(ixValue < zValues && nrofCharsParsed >0);
            }
          } else { //name in module not found though the module was found:
            thiz->errorCfg = mNameNotFound_TimeSignals_Inspc;
          }
        } //faulty module.
      } //name not exists.
      //search next variable:
      pos = indexOf_CI_StringJc(line, ',', pos) +1;  //0 if not found, then abort while. Else: more as one variable with the same time.
    }
    if(maxWhileNext <0){
      thiz->errorCfg |= mTooManyEntriesInLine_TimeSignals_Inspc; //too much lines
    }
  }
  STACKTRC_LEAVE;
}



